* replicaCount: 1 - в текущей версии параметр не менять.
* image.repository: iss/activemq-artemis
* image.pullPolicy: IfNotPresent 
* image.tag: ubunta-2.32.1
* persistence.enabled: true  - поставить fasle, если нет поддержки провайдера дисков, либо диски не нужны
* persistence.path: /var/lib/artemis/data  - том для данных БД redis
* persistence.accessModes: ReadWriteOnce
* persistence.size: 2Gi - изменить размер тома, если требуется другой

## Использование charts  
пакет находится в репозитории http://10.2.2.55/helm/incubator/  http://10.2.2.55/helm/stable/

Получить доступ к консоли activemq:
Найти сервис activemq:
```
kubectl get svc -n <Namespace> -o wide
```
Прокинуть порт на локальную машину : 
```
kubectl port-forward -n <Namespace>  svc/<activemq сервис> 7777:80 
```
Зайти на консоль graphite
```
http://localhost:7777 
```

Ниже представлены команды по запуску пакета, как самостоятельного сервиса
выполните следующий набор команд для установки пакета: 
```bash
helm repo add stable http://10.2.2.55/helm/stable/
helm repo update
```
для запуска activemq поддержкой pvc:
```bash
helm install <имя экз.> stable/activemq -n <namespace>
``` 
для запуска в тестовой среде (нет поддержки pvc)
 ```bash
 helm install <имя экз.> sem-next/activemq -n <namespace> --set master.persistence.enabled=false --set slave.persistence.enabled=false 
 ``` 
Для удаления пакета: 
```bash
helm uninstall <имя экз.> -n <namespace>
``` 



## Настройка кластера

Кластер работает в режиме ON_DEMAND.  описание его работы приведено
https://activemq.apache.org/components/artemis/documentation/latest/clusters.html

Изменить режим кластера можно в секции ниже , файла broker-00.xml
```bash
        <cluster-connections>
            <cluster-connection name="my-cluster">
              <connector-ref>artemis</connector-ref>
              <retry-interval>500</retry-interval>
              <use-duplicate-detection>true</use-duplicate-detection>
              <message-load-balancing>ON_DEMAND</message-load-balancing>
              <max-hops>1</max-hops>
              <discovery-group-ref discovery-group-name="discovery-group"/>
            </cluster-connection>
        </cluster-connections>
```bash

## Настройка использования artemis в многоузловом режиме

Режим использования artemis для многих узлов определяет переменные `addressSettingsOverrides`, `addressOverrides``:
При отсутсвии этой переменной, все очереди создаются согласно примеру ниже: 
```
 <address name="jms.queue.Event.{{ .Release.Namespace }}">
    <anycast>
       <queue name="jms.queue.Event.{{ .Release.Namespace }}"/>
    </anycast>
</address>
```
Если необходимо один инстанс JMS сервера использовать для многих инстансов semona, то необходимо применить описание как в примере ниже: 
```
addressSettingsOverrides:
  metrics_setting: |
    <address-setting match="jms.queue.Notify.metrics">
      <!-- через час сообщения устаревают и переносятся в очередь ExpiredNotifications -->
      <expiry-address>jms.queue.ExpiredNotifications.metrics</expiry-address>
      <expiry-delay>3600000</expiry-delay>
      <!-- повторная отправка через: 20 sec, 30 sec, 45 sec, ..., 300 sec -->
      <redelivery-delay>20000</redelivery-delay>
      <redelivery-delay-multiplier>1.5</redelivery-delay-multiplier>
      <max-redelivery-delay>300000</max-redelivery-delay>
      <!-- 50 неудачных отправок достаточно будет -->
      <max-delivery-attempts>50</max-delivery-attempts>
    </address-setting>
  test_setting: |
    <address-setting match="jms.queue.Notify.test">
      <!-- через час сообщения устаревают и переносятся в очередь ExpiredNotifications -->
      <expiry-address>jms.queue.ExpiredNotifications.test</expiry-address>
      <expiry-delay>3600000</expiry-delay>
      <!-- повторная отправка через: 20 sec, 30 sec, 45 sec, ..., 300 sec -->
      <redelivery-delay>20000</redelivery-delay>
      <redelivery-delay-multiplier>1.5</redelivery-delay-multiplier>
      <max-redelivery-delay>300000</max-redelivery-delay>
      <!-- 50 неудачных отправок достаточно будет -->
      <max-delivery-attempts>50</max-delivery-attempts>
    </address-setting>

addressOverrides: 
    metrics_setting: |
    <address name="jms.queue.Event.metrics">
       <anycast>
            <queue name="jms.queue.Event.metrics"/>
        </anycast>
    </address>
    <address name="jms.queue.Measure.metrics">
        <anycast>
            <queue name="jms.queue.Measure.metrics"/>
        </anycast>
    </address>
    <address name="jms.queue.Command.metrics">
        <anycast>
            <queue name="jms.queue.Command.metrics"/>
        </anycast>
    </address>
    <address name="jms.queue.CalcParam.metrics">
    <anycast>
    <queue name="jms.queue.CalcParam.metrics"/>
    </anycast>
    </address>
    <address name="jms.queue.SetValue.metrics">
    <anycast>
    <queue name="jms.queue.SetValue.metrics"/>
    </anycast>
    </address>
    <address name="jms.queue.Collector.metrics">
    <anycast>
    <queue name="jms.queue.Collector.metrics"/>
    </anycast>
    </address>
    <address name="jms.queue.Command.metrics">
    <anycast>
    <queue name="jms.queue.Command.metrics"/>
    </anycast>
    </address>
    <address name="jms.queue.Notify.metrics">
    <anycast>
    <queue name="jms.queue.Notify.metrics"/>
    </anycast>
    </address>
    <address name="jms.queue.ExpiredNotifications.metrics">
    <anycast>
    <queue name="jms.queue.ExpiredNotifications.metrics"/>
    </anycast>
    </address>
    
    test_setting: |
    <address name="jms.queue.Event.test">
    <anycast>
    <queue name="jms.queue.Event.test"/>
    </anycast>
    </address>
    <address name="jms.queue.Measure.test">
    <anycast>
    <queue name="jms.queue.Measure.test"/>
    </anycast>
    </address>
    <address name="jms.queue.Command.test">
    <anycast>
    <queue name="jms.queue.Command.test"/>
    </anycast>
    </address>
    <address name="jms.queue.CalcParam.test">
    <anycast>
    <queue name="jms.queue.CalcParam.test"/>
    </anycast>
    </address>
    <address name="jms.queue.SetValue.test">
    <anycast>
    <queue name="jms.queue.SetValue.test"/>
    </anycast>
    </address>
    <address name="jms.queue.Collector.test">
    <anycast>
    <queue name="jms.queue.Collector.test"/>
    </anycast>
    </address>
    <address name="jms.queue.Command.test">
    <anycast>
    <queue name="jms.queue.Command.test"/>
    </anycast>
    </address>    
    <address name="jms.queue.Notify.test">
    <anycast>
    <queue name="jms.queue.Notify.test"/>
    </anycast>
    </address>
    <address name="jms.queue.ExpiredNotifications.test">
    <anycast>
    <queue name="jms.queue.ExpiredNotifications.test"/>
    </anycast>
    </address>

```
